var dbui = window.dbui || {};
dbui.mp = dbui.mp || {};
//dbui.admin.tree = dbui.admin.tree || {};
(function (ns) {
    'use strict';
    var config =  {
        homeUrl: "/home/index",
        homeText: "首页",
        fixedTopbar: true,
        systemName: "管理系统",
        sideWidth: 200
    };
 
    var Tabs = function () {
        var tabs = [];
        var current = undefined;
        var container = $("#body").find(".pusher");
        var tabBar = container.find(".menu");
        var toggler = tabBar.find(".item.toggler");
        //tab class
        var Tab = function (data,from) {
            var tabTitle = $('<a class="item" data-tab="{0}">{1}<i class="icon remove"></i></a>'.format(data.key, data.t));
            tabBar.append(tabTitle);
            var h = $(window).height() - ns.topbar.height - tabBar.height();
            var tabBody = $('<div class="ui bottom attached tab segment" data-rel="{1}" data-tab="{0}" style="height:{2}px;">'.format(data.key, data.u, h));
            container.append(tabBody);
            tabTitle.tab({
                onFirstLoad: function (a, b) {
                    loadPage($(this));
                }, 
                onLoad: function (a, b) {
                    //reload = true;
                    loadPage($(this), true);
                },
                onVisible: function () {
                    var item = $(this);
                    var url = $(this).data("rel");
                    var txt = $(item).parent().find('.item[data-tab="{0}"]'.format($(item).data("tab"))).text();
                    ns.hash.setHash(url, txt);
                }
            });
            tabTitle.find(".icon.remove").on("click", closeTab);
            tabTitle.click();
            this.parent = from;
        };
        this.openTab = function() {

        };
        this.refresTab = function() {

        };
        this.activeTab = function() {

        };
        this.closeTab = function() {

        };
    };

    ns.Hash = function () {
        var data = {};
        var ingore = false;
        var construct = function () {
            if ("onhashchange" in window) {
                window.onhashchange = function () {
                    if (ingore) {//不做hash变更，说明点击的是激活页
                        ingore = false;
                        return false;
                    }
                    hash();
                    ns.body.openTab();
                };
            } else {
                console.error("该浏览器不支持onhashchange事件");
            }
            if (location.hash === '') {
                location.hash = hash({ u: ns.conf.homeUrl, t: ns.conf.homeText });
            }
            hash();
        };
        var hash = function (val) {
            if (typeof val === "object") {
                var str = "#";
                for (var key in val) {
                    str += "{0}={1}&".format(key, encodeURI(val[key]));
                }
                return str;
            }
            if (typeof val === 'undefined') val = location.hash;
            val = val.replace('#', '');
            var args = val.split('&');
            for (var i = 0; i < args.length; i++) {
                var pair = args[i].split('=');
                data[pair[0]] = decodeURI(pair[1]); 
            }
            data.key = data.u.replace(/\//g, '');
            return data;
        };
        this.setHash = function (url, text) {
            var h = hash({ u: url, t: text });
            if (h !== location.hash) {
                ingore = true;
                window.location.hash = h;
            }
        };
        this.data = data;
        this.hash = hash;
        construct();
    };
    ns.Sidebar = function () {
        var sidebar = $(".ui.sidebar");
        var construct = function () {
            //开启折叠功能
            sidebar.accordion({
                exclusive: true
            });
            //边栏配置
            if (ns.conf.sideWidth) sidebar.width(ns.conf.sideWidth);
            sidebar.sidebar({
                context: "#body",
                dimPage: false,
                closable: false,
                onVisible: function () {
                    ns.body.push();

                }, onHide: function () {
                    ns.body.pull();
                }
            }).sidebar('attach events', '.toggler');
            sidebar.sidebar("show");
            var items = sidebar.find(".item a[href]");
            items.each(function (i, item) {
                var obj = $(item);
                obj.attr("href", ns.hash.hash({ u: obj.attr("href"), t: obj.text() }));
            });
            sidebar.find("h1.header").text(ns.conf.fixedTopbar ? "功能模块" : ns.conf.systemName);
        };
        this.show = function () {
            sidebar.sidebar("show");
        };

        construct();
    };
    ns.Topbar = function () {
        var bar = $("#topbar");
        var construct = function () {
            var m = bar.find(".right.menu");
            m.before("<div class='item header'>" + ns.conf.systemName + "</div>");

            $(".ui.dropdown").dropdown();
            ns.action.init(bar);
        };
        this.height = bar.height();
        construct();
    };
    ns.Body = function () {
        var body = $("#body").find(".pusher");
        var tabBar = body.find(".menu");
        var toggler = tabBar.find(".item.toggler");
        var reload = false;
        var loadPage = function (obj, checkReload) {
            if (checkReload && !reload) return;
            obj.addClass("loading");
            obj.load(obj.data("rel"),
                function () {
                    ns.action.init($(this)); //初始化页面中的相关行为
                    ns.permission.init($(this));
                    ns.editor.init($(this));
                    ns.calendar.init($(this));
                    ns.uploader.init($(this));
                    ns.dropdown.init($(this));
                    ns.selectableCard.init($(this));
                    ns.querySelector.init($(this));
                    if (ns.form) ns.form.init($(this));
                    //if (ns.pager) ns.pager.init($(this));

                    obj.removeClass("loading");
                });
        };
        var addTab = function (d) {
            var tabTitle = $('<a class="item" data-tab="{0}">{1}<i class="icon remove"></i></a>'.format(d.key, d.t));
            tabBar.append(tabTitle);
            var h = $(window).height() - ns.topbar.height - tabBar.height();
            var tabBody = $('<div class="ui bottom attached tab segment" data-rel="{1}" data-tab="{0}" style="height:{2}px;">'.format(d.key, d.u, h));
            body.append(tabBody);
            tabTitle.tab({
                onFirstLoad: function (a, b) {
                    loadPage($(this));
                },
                onLoad: function (a, b) {
                    //reload = true;
                    loadPage($(this), true);
                },
                onVisible: function () {
                    var item = $(this);
                    var url = $(this).data("rel");
                    var txt = $(item).parent().find('.item[data-tab="{0}"]'.format($(item).data("tab"))).text();
                    ns.hash.setHash(url, txt);
                }
            });
            tabTitle.find(".icon.remove").on("click", closeTab);
            tabTitle.click();
        };
        var closeTab = function () {
            if (tabBar.children().length === 2) {//只剩一个内容tab的时候不错移除
                dbui.modal.alert("只剩一个可用页面，不能关闭");
                return;
            }

            //移除
            body.find('[data-tab="' + $(this).parent().data("tab") + '"]').remove();
            $(this).parent().remove();

            //设置激活状态
            tabBar.children("a:last-child").click();
        };
        var closeActiveTab = function () {
            body.find("a.active,div.tab.active").remove();
            //设置激活状态
            tabBar.children("a:last-child").click();
        };
        var openTab = function () {
            var tab = tabBar.find('[data-tab="{0}"]'.format(ns.hash.data.key));
            if (tab.length > 0) {
                reload = true;//触发openTab需要在click时，重新加载页面
                tab.click();
            } else {
                addTab(ns.hash.data);
            }
        };
        var construct = function () {
            tabBar.find(".icon.toggler").on("click", function () {
                ns.sidebar.show();
            });
            openTab();

        };
        this.pull = function () {
            toggler.show();
            body.width($(document).width());
        };
        this.push = function () {
            toggler.hide();
            body.width($(document).width() - ns.conf.sideWidth)
        };
        this.closeActiveTab = closeActiveTab;
        this.openTab = openTab;
        construct();
    };
    ns.Action = function () {
        var $body;
        var window = function (sender) {
            var title = sender.data("text") ? sender.data("text") : sender.text();
            dbui.modal.window(title, sender.data("rel"), function () {
                var callback = sender.data("callback");
                eval("window." + callback + "()");
            });
            return false;
        };
        var search = function ($sender, p) {
            if (typeof $sender === 'undefined') {
                $sender = $body.hasClass("docker") ? $body.parents(".tab.active:first").find(".action.search") : $body.find(".action.search");
            }

            var form = $sender.parents("form:first");
            var docker = $body.hasClass("docker") ? $body : $body.find(".data.docker");
            var url = form.attr("action");
            url += (url.indexOf('?') >= 0 ? "&" : "?") + form.serialize();
            if (p) url += "&p=" + p;
            docker.load(url, function (rs) {
                //加载成功后需要重新加载对应的action或组件
                ns.action.init($body);
            }, function (rs) {
                dbui.modal.alert(rs.message);
            });
        };
        var remove = function ($sender) {
            var url = $sender.data("rel");
            var id = $sender.data("id");
            dbui.modal.confirm("确定删除此条数据", function () {
                dbui.http.post(url, [id], function () {
                    search();
                }, function (code, msg, rs) {
                    dbui.modal.alert(msg);
                });
            });
        };
        var removeMany = function ($sender) {
            var url = $sender.data("rel");
            var list = $body.find(".data.docker table .checkbox.checked");
            if (list.length === 0) {
                dbui.modal.alert("没有选中任何要删除的项目");
            } else {
                var arr = [];
                list.each(function (i, item) {
                    arr.push($(item).children().data("id"));
                });
                dbui.modal.confirm("确定删除此条数据", function () {
                    dbui.http.post(url,
                        { idList: arr },
                        function () {
                            search();
                        },
                        function (code, msg, rs) {
                            dbui.modal.alert(msg);
                        });
                });
            }
        };

        var operate = function ($sender) {
            var url = $sender.data("rel");
            if ($sender.data("confirm")) {
                dbui.modal.confirm($sender.data("confirm"),
                    function () {
                        dbui.http.post(url,
                            JSON.parse($sender.data("params")),
                            function () {
                                search();
                            },
                            function (code, msg, rs) {
                                dbui.modal.alert(msg);
                            });
                    });
            } else {
                dbui.http.post(url,
                    JSON.parse($sender.data("params")),
                    function () {
                        search();
                    },
                    function (code, msg, rs) {
                        dbui.modal.alert(msg);
                    });
            }
        };
        var init = function ($page) {
            $body = $page;
            var actions = $body.find(".action");
            actions.each(function (i, item) {
                var $obj = $(item);
                if ($obj.hasClass("outer")) {
                    $obj.attr("target", "_blank");
                } else if ($obj.hasClass("inner")) {
                    var txt = $obj.data("text") ? $obj.data("text") : $obj.text();
                    $obj.attr("href", ns.hash.hash({ u: $obj.attr("href"), t: txt }));
                } else {
                    if (typeof $obj.attr("href") !== 'undefined' && $obj.attr("href") !== "#") {
                        $obj.attr("data-rel", $obj.attr("href"));
                        $obj.attr("href", "#");
                    }
                    $obj.off("click");
                    $obj.on("click", function () {
                        if ($obj.hasClass("window")) {
                            window($obj);
                        } else if ($obj.hasClass("search")) {
                            search($obj);
                        } else if ($obj.hasClass("remove")) {
                            remove($obj);
                        } else if ($obj.hasClass("removeMany")) {
                            removeMany($obj);
                        } else if ($obj.hasClass("operate")) {
                            operate($obj);
                        }
                        return false;
                    });
                }
            });
            $body.find(".ui.checkbox").checkbox();
            //分页初始化
            if (ns.pager) ns.pager.init($page, function (pageNo) {
                search(undefined, pageNo);
            });
        };
        //this.reload = function (pageNo) {
        //    search(undefined, pageNo);
        //};
        this.init = init;
    };
    ns.QuerySelector = function () {
        var selector = ".selector.query";
        var openDialog = function ($sender, $input) {
            var title = $sender.data("title");
            var url = $sender.data("url");
            dbui.modal.dialog(title, {
                url: url,
                ok: function ($content) {
                    var item = $content.find(".checkbox.checked");
                    $sender.val(item.data("id"));
                    $input.val(item.data("text"));
                },
                onLoad: function ($content) {
                    ns.action.init($content); //初始化页面中的相关行为
                    ns.calendar.init($content);
                    ns.dropdown.init($content);
                    ns.querySelector.init($content);
                    //if (ns.pager) ns.pager.init($content);
                }
            });
        };
        var create = function ($sender) {
            var $select =
                $('<div class="ui action input"><input type= "text" placeholder= "' + $sender.data("title") + '"><button class="ui icon button"><i class="search icon"></i></button> </div >');
            $select.find("input").val($sender.data("text"));

            $select.find("button").on("click", function () {
                openDialog($sender, $select.find("input"));
                return false;
            });
            $sender.after($select);
        };
        var init = function ($page) {
            $page.find(selector).each(function (i, item) {
                create($(item));
            });
        };
        this.init = init;
    };
    ns.Permission = function () {
        var $body;
        var $target;
        var setValue = function () {
            var val = "";
            $body.find(".ui.checkbox.checked").each(function (i, item) {
                val += $(item).data("rel") + ",";
            });
            $target.val(val);
        };
        var check = function ($obj) {
            if ($obj.parent().hasClass("module") || $obj.parent().hasClass("controller")) {
                $obj.siblings().find(".ui.checkbox").checkbox("set checked");
            }
        };
        var uncheck = function ($obj) {
            if ($obj.parent().hasClass("module") || $obj.parent().hasClass("controller")) {
                $obj.siblings().find(".ui.checkbox").checkbox("set unchecked");
            }
        };
        var init = function () {
            $body.find(".ui.checkbox").each(function (i, item) {
                $(item).checkbox({
                    onChecked: function () {
                        check($(this).parent());
                        setValue();
                    },
                    onUnchecked: function () {
                        uncheck($(this).parent());
                        setValue();
                    }
                });
            });
        };
        this.init = function ($page) {
            $body = $page.find(".permission.list");
            $target = $($body.data("rel"));
            if ($body.length > 0) {
                init();
            }
        };
    };
    ns.Editor = function () {
        var BackgroundClass = Quill.import('attributors/style/background');
        var ColorClass = Quill.import('attributors/style/color');
        var FontSize = Quill.import('attributors/style/size');
        var FontFamily = Quill.import('attributors/style/font');
        var Align = Quill.import('attributors/style/align');
        var Direction = Quill.import('attributors/style/direction');
        var Icons = Quill.import('ui/icons');

        Icons['fullScreen'] = '<i class="expand icon"></i>';
        Icons['showHtml'] = '<span>HTML</span>';
        //字体部分
        Icons['bold'] = '<i class="bold icon"></i>';
        Icons['italic'] = '<i class="italic icon"></i>';
        Icons['underline'] = '<i class="underline icon"></i>';
        Icons['strike'] = '<i class="strikethrough icon"></i>';
        Icons['image'] = '<i class="image icon"></i>';
        Icons['video'] = '<i class="video icon"></i>';

        FontSize.whitelist =
            ['10px', '12px', '14px', '16px', '18px', '24px', '32px', '48px'];

        FontFamily.whitelist = ['sans-serif',
            'Microsoft YaHei', '微软雅黑',
            'SimSun',
            '楷体', '楷体_GB2312', 'SimKai',
            '黑体', 'SimHei',
            '隶书', 'SimLi',
            'STSong'
        ];

        Quill.register(BackgroundClass, true);
        Quill.register(ColorClass, true);
        Quill.register(FontSize, true);
        Quill.register(FontFamily, true);
        Quill.register(Align, true);
        Quill.register(Direction, true);

        var toolbarOptions = [
            [{ 'font': ['sans-serif', 'Microsoft YaHei', 'SimSun', 'SimKai', 'SimHei', 'SimLi', 'STSong'] }, { 'size': ['10px', '12px', '14px', '16px', '18px', '24px', '32px', '48px'] }, { 'color': [] }, { 'background': [] }],
            //加粗等
            ['bold', 'italic', 'underline', 'strike', { 'align': [] }],
            //代码块
            ['blockquote', 'code-block'],

            //上下文字，比如次方这样的输入
            // [{'header': 1}, {'header': 2}], 
            [{ 'list': 'ordered' }, { 'list': 'bullet' }],
            //将文字左右颠倒
            [{ 'script': 'sub' }, { 'script': 'super' }],
            //文章开头缩进方式
            [{ 'indent': '-1' }, { 'indent': '+1' }],
            [{ 'direction': 'rtl' }],

            //标题大小设置
            // [{'header': [1, 2, 3, 4, 5, 6, false]}],

            ['image', 'video'],
            //清除样式
            ['clean'],
            ['showHtml'],
            ['fullScreen']
        ];

        var saveToServer = function (file, quill) {
            var fd = new FormData();
            fd.append('file', file);
            var mask = $('<div class="ui inverted dimmer"><div class="ui text loader"></div></div>');
            $(quill.container).append(mask);
            $(quill.container).dimmer("show");
            dbui.http.postFile(ns.conf.uploadUrl, fd, function (data) {
                var result = data;
                var range = quill.getSelection();
                var url = result.host + result.path;
                quill.insertEmbed(range.index, 'image', url);
                mask.remove();
            });
        };

        var selectLocalImage = function () {
            var quill = this.quill;
            var input = document.createElement('input');
            input.setAttribute('type', 'file');
            input.click();
            input.onchange = function () {
                var file = input.files[0];
                saveToServer(file, quill);
            }
        };

        this.init = function (page) {
            var editors = page.find(".editor");
            if (editors.length === 0) return;
            editors.each(function (i, item) {
                $(item).hide();
                var editor = $("<div></div>");
                $(item).after(editor);
                var quill = new Quill(editor[0], {
                    modules: {
                        toolbar: toolbarOptions,
                        imageDrop: true,
                        imageResize: {}
                    },
                    theme: 'snow'
                });
                if (item.value !== "") quill.container.querySelector('.ql-editor').innerHTML = item.value;
                quill.getModule('toolbar').addHandler('image', selectLocalImage);
                quill.on('text-change', function () {
                    item.value = quill.container.querySelector('.ql-editor').innerHTML;
                });

                //源码编辑支持
                var sourceButton = document.querySelector('.ql-showHtml');
                sourceButton.addEventListener('click', function () {
                    var html = item.value;
                    var container = quill.container;
                    var editor = container.querySelector('.ql-editor');
                    var sourceArea = document.getElementById('source_area');

                    //如果不存在，先创建一个显示源码的文本框
                    if (!sourceArea) {
                        sourceArea = document.createElement('textarea');
                        sourceArea.setAttribute('id', 'source_area');
                        sourceArea.style.color = 'white';
                        sourceArea.style.backgroundColor = '#272822';
                        sourceArea.style.outline = 'none';
                        sourceArea.style.border = 'none';
                        sourceArea.style.width = '100%';
                        sourceArea.style.height = '100%';
                    }

                    if (editor.style.display !== 'none') {
                        editor.style.display = 'none';
                        sourceArea.style.display = 'block';
                        sourceArea.value = html;
                        container.appendChild(sourceArea);
                    } else {
                        editor.style.display = 'block';
                        sourceArea.style.display = 'none';
                        editor.innerHTML = sourceArea.value;
                    }

                });

                //全屏支持
                var fullScreenButton = document.querySelector('.ql-fullScreen');
                fullScreenButton.addEventListener('click', function () {
                    if (screenfull.enabled) {
                        var $container = $('.fourteen.wide.field');
                        $container.css({
                            'margin-top': '30px'
                        });
                        screenfull.request($container[0]);
                    } else {
                        console.error('浏览器不支持全屏');
                    }
                });
            });

        };
    };
    ns.Calendar = function () {
        var text = {
            days: ['周日', '周一', '周二', '周三', '周四', '周五', '周六'],
            months: ['一月', '二月', '三月', '四月', '五月', '六月', '七月', '八月', '九月', '十月', '十一月', '十二月'],
            monthsShort: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
            today: '今日',
            now: '现在',
            am: '上午',
            pm: '下午'
        };
        var formatter = {
            datetime: function (date) {
                if (!date) {
                    return '';
                }
                return date.format("yyyy/MM/dd HH:mm:ss");
            },
            date: function (date) {
                if (!date) {
                    return '';
                }
                return date.format("yyyy/MM/dd");
            }
        };
        this.init = function (page) {
            var calendars = page.find(".calendar");
            calendars.each(function (i, item) {
                var t = item.data("type");
                if (t === "") t = "date";
                item.calendar({ type: t, text: text, formatter: formatter });
            });
        };
    };
    ns.init = function (conf) {
        //ns.conf = new ns.Config(conf ? conf : {});//初始化配置项
        config = conf ? $.extend(config, conf) : config;
        ns.hash = new ns.Hash();
        ns.action = new ns.Action();
        ns.topbar = new ns.Topbar();
        ns.body = new ns.Body();
        ns.sidebar = new ns.Sidebar();
        ns.permission = new ns.Permission();
        ns.editor = new ns.Editor();
        ns.calendar = new ns.Calendar();
        ns.querySelector = new ns.QuerySelector();
        if (dbui.Pager)
            ns.pager = new dbui.Pager();
        if (dbui.Form)
            ns.form = new dbui.Form({
                onSubmitSuccess: function (rs, obj) {
                    ns.body.closeActiveTab();
                },
                onSubmitFailed: function (msg, obj) {
                    dbui.modal.alert(msg);
                }
            });
        if (dbui.Uploader)
            ns.uploader = new dbui.Uploader(conf.uploader);
        if (dbui.Dropdown) {
            ns.dropdown = new dbui.Dropdown();
        }
        if (dbui.SelectableCard) {
            ns.selectableCard = new dbui.SelectableCard();
        }
    };

})(dbui.mp);
//dropdown
(function (ns) {
    ns.Dropdown = function () {
        var $body;
        var dropdownRemote = function ($sender, query) {
            var url = $sender.data("url");
            if (url.indexOf("{query}") >= 0) {
                if (query === undefined) return;//级联选择框的子级则不进行自动加载
                url = url.replace("{query}", query);
            }

            var $select = $sender.parent();
            $select.addClass("loading");
            dbui.http.get(url, function (rs) {
                var val = $sender.val();
                var additions = $sender.data("additions");
                //additions = additions !== undefined && additions !== "";
                $select.dropdown({
                    values: rs,
                    allowCategorySelection: true,
                    //allowAdditions: additions,
                    onChange: function (value, text, $choice) {
                        if ($choice === undefined) return false;
                        var $rel = $body.find($sender.data("rel")); //rel有值则说明有二级级联菜单
                        if ($sender.data("changed") !== undefined) {
                            eval($sender.data("changed") + "(" + value + ")");
                        };
                        if ($rel.length > 0) {
                            dropdownRemote($rel, value);
                        }
                        return true;
                    }
                });
                if (val !== undefined && val != null && val !== "0") {
                    $select.dropdown("set selected", val.split(','));
                }
                $select.removeClass("loading");
            });
        };
        var dropdown = function ($sender) {
            //此处需要将select换成hidden input
            var $input = $("<input type='hidden'></input>");
            $.each($sender[0].attributes, function (i, item) {
                $input.attr(item.name, item.value);
            });
            $sender.dropdown({
                placeholder: $sender.attr("placeholder")
            });
            $sender.before($input);
            $sender.remove();
        };
        this.init = function ($page) {
            $body = $page;
            var selects = $body.find(".dropdown");
            selects.each(function (i, item) {
                dropdown($(item));
            });
            selects = $body.find("input.dropdown");
            selects.each(function (i, item) {
                dropdownRemote($(item));
            });
        };
    };
})(dbui);
//selectableCard
(function (ns) {
    ns.SelectableCard = function () {
        var selector = ".selectable.cards";
        var $body;
        var create = function ($sender) {
            var url = $sender.data("url");
            if (url.indexOf("{query}") >= 0) {
                if (query === undefined) return;//级联选择框的子级则不进行自动加载
                url = url.replace("{query}", query);
            }

            var val = $sender.data("value");
            dbui.http.get(url, function (rs) {
                $.each(rs, function (i, item) {
                    var card = $('<div class="card"><div class="image"> <img /> </div> </div>');
                    card.find("img").attr("src", item.image);
                    card.append('<div class="extra">' + item.text + '</div>');
                    card.attr("data-value", JSON.stringify(item.value));
                    if (val !== undefined && val !== "") {

                    }
                    $sender.append(card);
                });
            });
        }
        this.init = function ($page) {
            $body = $page;
            var $cards = $body.find(selector);
            $cards.each(function (i, item) {
                create($(item));
            });

        };
    };
})(dbui);